import type { SzPlatformClient } from '../classes.platformclient.js';
import { logger } from '../logger.js';
import * as plugins from '../plugins.js';

export class SzSmsConnector {
  public platformClientRef: SzPlatformClient;

  constructor(platformClientRefArg: SzPlatformClient) {
    this.platformClientRef = platformClientRefArg;
  }

  public async sendSms(messageArg: plugins.servezoneInterfaces.platformservice.sms.IRequest_SendSms['request']) {
    if (process.env.SERVEZONE_PLATFORMCLIENT_DEBUG) {
      logger.log('info', `sent sms to ${messageArg.toNumber}}
        body: 
        ${messageArg.messageText.split('\n').map(line => `       ${line}`).join('\n')}

        `);
    }
    
    const typedrequest = this.platformClientRef.typedsocket.createTypedRequest<plugins.servezoneInterfaces.platformservice.sms.IRequest_SendSms>(
      'sendSms'
    );
    const response = await typedrequest.fire(messageArg);

    return response.status;
  }

  public async sendSmsVerifcation(
    recipientArg: plugins.servezoneInterfaces.platformservice.sms.IRequest_SendVerificationCode['request']
  ) {
    const typedrequest =
      this.platformClientRef.typedsocket.createTypedRequest<plugins.servezoneInterfaces.platformservice.sms.IRequest_SendVerificationCode>(
        'sendVerificationCode'
      );
    const response = await typedrequest.fire(recipientArg);
    return response.verificationCode;
  }
}
